/***************************************************************************
                          audiocodec_ogg.cpp  -  description
                             -------------------
    begin                : Thu May 23 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr

	Strongly inspired by mplayer ogg vorbis decoder
	(ripp off should be more appropriate)
	
    
 ***************************************************************************/


/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "config.h"
#ifdef HAVE_OGG
#include <vorbis/codec.h>
#include "avi_vars.h"


#define BUFFER_SIZE 4*4096

static uint8_t initLoop(void);


static uint8_t started=0;
static uint8_t init_req=0;
static uint8_t localbuffer[2*BUFFER_SIZE];
static uint32_t inbuffer=0;


 ogg_sync_state    oy;  // sync and verify incoming physical bitstream
 ogg_stream_state  os;  // take physical pages, weld into a logical stream of packets
 ogg_page          og;  // one Ogg bitstream page. Vorbis packets are inside
 ogg_packet        op;  // one raw packet of data for decode
 vorbis_info       vi;  // struct that stores all the static vorbis bitstream settings
 vorbis_comment    vc;  // struct that stores all the bitstream user comments
 vorbis_dsp_state  vd;  // central working state for the packet->PCM decoder
 vorbis_block      vb;  // local working space for packet->PCM decode


uint8_t   	    ADM_OggInit(void )
{
 	started=1;
  	init_req=1;
   inbuffer=0;
   ogg_sync_init(&oy); /* Now we can read pages */
  return 1;
}

//__________________________________________
//
//                      End Ogg decoder
//__________________________________________
uint8_t ADM_OggEnd(void)
{

   	started=0;
  	init_req=0;
   return 1;
}
//
//	Run ogg decoder , returns how much decoded
// if init req, try initializing
//
uint8_t ADM_OggRun(uint8_t * ptr, uint32_t nbIn, uint8_t * outptr,
		    uint32_t * nbOut)
{
uint32_t handle;

	*nbOut=0;
	assert(started);
 		
   // 1 st step store !	
reloop:
		if(inbuffer<BUFFER_SIZE)
  		{
        	handle= BUFFER_SIZE-  inbuffer;
         	if(handle>nbIn)
          		{
               	handle=nbIn;
              }
         	   memcpy(ptr+inbuffer,ptr,  handle);
             nbIn-=handle;
             ptr+=handle;
             inbuffer+=handle;
      	}

 	if(init_req)
 	{
    	return initLoop();
     }
     return 0;

}
//__________________________________________
//
//
//__________________________________________
uint8_t initLoop(void)
{
char *buffer;
int		bytes;

    	// First we prestore BUFFER_SIZE /2
      // before oing anything else
     	if(inbuffer<(BUFFER_SIZE>>1))
      	{
          	return 1;
         }


   	ogg_sync_init(&oy);

	while( ogg_sync_pageout( &oy, &og )!=1 ) {
		buffer = ogg_sync_buffer( &oy, 1024 );
		//bytes = fread( buffer, 1, 1, f );
  		memcpy(buffer,localbuffer,1024);
    	for(uint32_t i=0;i<1024;i++)
     		{
            	localbuffer[i]=localbuffer[i+1024];
         	}
          inbuffer-=1024;
  		bytes=1024;
		ogg_sync_wrote( &oy, bytes );
	}
 	// we got synchro now !
	ogg_stream_init( &os, ogg_page_serialno( &og ) );

	vorbis_info_init( &vi );
	vorbis_comment_init( &vc );
	if( ogg_stream_pagein( &os, &og )<0 )
   {
		return 0;
	}
	if( ogg_stream_packetout( &os, &op )!=1 )
   {
		return 0;
	}
	if( vorbis_synthesis_headerin( &vi, &vc, &op )<0 ) {
		return 0;
	}
	


	return 0;
}

#if 0

	   /* submit a 4k block to libvorbis' Ogg layer */
    	ogg_sync_init(&oy);
   		buffer=ogg_sync_buffer(&oy,4096);	
       memcpy(buffer,localbuffer,4096);
	   ogg_sync_wrote(&oy,4096);

	   /* Get the first page. */
  		 if(ogg_sync_pageout(&oy,&og)!=1)
       	{
     			/* error case.  Must not be Vorbis data */
    			 printf(  "Error initializing Ogg bitstream data.\n" );
			     return 0;
   				}

	    /* Get the first page. */
   if(ogg_sync_pageout(&oy,&og)!=1)
     {
     	/* error case.  Must not be Vorbis data */
     	printf(  "Error initializing Ogg bitstream data.\n" );
     	return 0;
	   }

   /* Get the serial number and set up the rest of decode. */
   /* serialno first; use it to set up a logical stream */
   ogg_stream_init(&os,ogg_page_serialno(&og));

   /* extract the initial header from the first page and verify that the
      Ogg bitstream is in fact Vorbis data */

   /* I handle the initial header first instead of just having the code
      read all three Vorbis headers at once because reading the initial
      header is an easy way to identify a Vorbis bitstream and it's
      useful to see that functionality seperated out. */

   vorbis_info_init(&vi);
   vorbis_comment_init(&vc);
   if(ogg_stream_pagein(&os,&og)<0){
     /* error; stream version mismatch perhaps */
     printf(  "Error reading first page of Ogg bitstream data.\n" );
     return 0;
   }

   if(ogg_stream_packetout(&os,&op)!=1){
     /* no page? must not be vorbis */
     printf( "Error reading initial header packet.\n" );
     return 0;
   }
#endif
 	
#endif
