/***************************************************************************
                          adm_encConfig.cpp  -  description
                             -------------------
    begin                : Thu Dec 26 2002
    copyright            : (C) 2002 by mean
    email                : fixounet@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <math.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>
#include <config.h>

#include "gui_action.hxx"
#ifdef USE_FFMPEG
#include "ADM_lavcodec.h"
#endif

#include "fourcc.h"
#include "avi_vars.h"
#include "ADM_toolkit/toolkit.hxx"

#include "ADM_encoder/ADM_vidEncode.hxx"

#include "ADM_video/ADM_genvideo.hxx"
#include "ADM_encoder/adm_encoder.h"
#include "ADM_encoder/adm_encConfig.h"
#include "prefs.h"
#ifdef USE_DIVX
#include "ADM_codecs/ADM_divxEncode.h"
#include "ADM_encoder/adm_encdivx.h"
#endif

#include "ADM_toolkit/ADM_debugID.h"
#define MODULE_NAME MODULE_ENCODER
#include "ADM_toolkit/ADM_debug.h"


extern void UI_setVProcessToggleStatus( uint8_t status );
extern void GUI_setVideoCodec(Action action );
static void setVideoEncoderSettings(COMPRESSION_MODE mode, uint32_t  param,
								uint32_t extraConf, uint8_t *extraData);
extern int getCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fs);

// Put that in a proper include...
extern void oplug_mpeg_vcd(char *name);
extern void oplug_mpeg_svcd(char *name);
extern void oplug_mpeg_dvd(char *name);
extern void oplug_mpeg_svcdConf( void );
extern void oplug_mpeg_dvdConf( void );

extern void oplug_mpegff_conf(void);

#ifdef USE_XX_XVID
	#include "ADM_codecs/ADM_xvid.h"
	#include "ADM_encoder/adm_encxvid.h"
	#include "xvid.h"

  extern int DIA_getXvidCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,xvidEncParam *param);
#endif


#ifdef USE_FFMPEG
  #include "ADM_codecs/ADM_ffmpeg.h"
	#include "ADM_encoder/adm_encffmpeg.h"

extern int getFFCompressParams(COMPRESSION_MODE * mode, uint32_t * qz,
		      uint32_t * br,uint32_t *fsize,FFcodecSetting *conf);
#endif

#ifdef USE_FFMPEG
    #include "ADM_codecs/ADM_mjpegEncode.h"
	#include "ADM_encoder/adm_encmjpeg.h"
#endif



/*
  	Codec settings here

*/
#ifdef USE_FFMPEG
  FFMPEGConfig ffmpegConfig={
  	{COMPRESS_CQ,4,1500,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC	
	 1,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 0, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking; 
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */
	0,		// min bitrate in kB/S
	0,		// max bitrate
	0, 		// default matrix
	0, 		// no gop size
	NULL,
	NULL
 	} 
  };

  // mpeg1
  
 FFMPEGConfig ffmpegMpeg1Config={
  	{COMPRESS_CBR,4,1500000,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC
	 0,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;   =1 means no B frame
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 1, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking;
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */
	(600*1000>>3),		// min bitrate in kB/S
	(2200*1000)>>3,		// max bitrate
	0,					// user_matrix 0->default, 1 tmpg, 2 anim , 3 kvcd
	12,					// Safe gop size limit
	NULL,				// inter & intra matrix, will be set depending on user_matrix
	NULL
 	}
  };
 FFMPEGConfig mpeg2encSVCDConfig={
  	{COMPRESS_CBR,4,1500000,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC
	 0,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;   =1 means no B frame
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 1, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking;
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */
	(600*1000>>3),		// min bitrate in kB/S
	(2200*1000)>>3,		// max bitrate
	0,					// user_matrix 0->default, 1 tmpg, 2 anim , 3 kvcd
	12,					// Safe gop size limit
	NULL,				// inter & intra matrix, will be set depending on user_matrix
	NULL,
	0,				// interlaced
	0				// widescreen
 	}
  };
  FFMPEGConfig mpeg2encDVDConfig={
  	{COMPRESS_CBR,4,1500000,700},
	{
	 ME_EPZS,//	ME
	 0, // 		GMC
	 0,//		_4MV;
	 0,//		_QPEL;
	 1,//		_HQ;   =1 means no B frame
	 0,//		_TREILLIS_QUANT
	 2,//		qmin;
	 31,//		qmax;
	 3,//		max_qdiff;
	 0,//		max_b_frames;
	 1, //		mpeg_quant;
	 -2, // 		luma_elim_threshold;
	 -5, // 		chroma_elim_threshold;
	 0.05,//		lumi_masking;
	 0.01,//		dark_masking;
 	 0.5,// 	qcompress;  /* amount of qscale change between easy & hard scenes (0.0-1.0)*/
    	 0.5,// 	qblur;      /* amount of qscale smoothing over time (0.0-1.0) */
	(600*1000>>3),		// min bitrate in kB/S
	(2200*1000)>>3,		// max bitrate
	0,					// user_matrix 0->default, 1 tmpg, 2 anim , 3 kvcd
	12,					// Safe gop size limit
	NULL,				// inter & intra matrix, will be set depending on user_matrix
	NULL,
	0,				// interlaced
	0				// widescreen
 	}
  };


#endif
/*

*/
#ifdef USE_XX_XVID
 static XVIDconfig  xvidConfig={{COMPRESS_CQ,4,1500,700},
                    {
	 5, // High ME algo
	 0, // interlaced;
	 1, // inter4v;
	 XVID_H263QUANT,// quantizer;
	 2,// imin;
	 31, // imax;
	 2 ,// pmin;
	 31, // pmax;
	 
	 0,// lumi;

 	 XVID_ME_PMVFAST, // me;
	 1,// halfpel  ;

	 
	 10, // kfboost;
	 1, // min_key_interval;
	 300, // max_key_interval;
	 
	 	25, // curve_compression_high;
		10, // curve_compression_low;

		240, // 	bitrate_payback_delay;
	 
	

	 0,// startcred_start;
	 0,// startcred_end;
	

	 0,// endcred_start;
	 0,// endcred_end;
	 
	 0,// cred_rate;
	 

	1, // use_alt_curve;
	2, //VBR_ALT_CURVE_LINEAR, //int alt_curve_type;
	90, // alt_curve_low_dist;
	500, // alt_curve_high_dist;
	50, // alt_curve_min_rel_qual;
	1, // alt_curve_use_auto;
	1, // alt_curve_auto_str;
	1, // alt_curve_use_auto_bonus_bias;
	50, // alt_curve_bonus_bias;
	1//VBR_PAYBACK_BIAS // bitrate_payback_method 	 ;
//	"/tmp/Xvid2passLog.txt"; // path

										}
 										};;

#endif
#ifdef USE_DIVX
 static DIVXConfig  divxConfig={{COMPRESS_CQ,4,1500,700}};
 																
#endif

#ifdef USE_FFMPEG
static MJPEGConfig mjpegConfig={90,0};

extern uint8_t DIA_mjpegCodecSetting( int *qual, int *swap );
#endif
char TwoPassLogFile[300]; 


///////////////////////////////////////////
#ifdef USE_DIVX
SelectCodecType current_codec=CodecDivx;
#else
SelectCodecType current_codec=CodecFF;
#endif

EXTERN uint32_t videoProcessMode;

CodecFamilty videoCodecGetFamily( void )
{
	if(current_codec==CodecXVCD || current_codec==CodecXSVCD)
			return CodecFamilyXVCD;
	if(current_codec==CodecVCD || current_codec==CodecSVCD|| current_codec==CodecDVD)
			 return CodecFamilyMpeg;
	return CodecFamilyAVI;

}
	#define Read(x) { \
		tmp=name; \
		if((tmp=strstr(name,#x))) \
			{ \
				tmp+=strlen(#x); \
				aprintf("-- %s\n",tmp); \
				sscanf(tmp,"=%d ",&x); \
			} \
			 else \
			{ printf("*** %s not found !***\n",#x);} \
		}
#define Add(x) {sprintf(tmp,"%s=%d ",#x,x);strcat(conf,tmp);}

/*
	Ultimately that will be dispatched on a per codec
	stuff and will be merged with xml stuff to allow
	save config / load config
*/
void videoCodecSetConf(  char *name,uint32_t extraLen, uint8_t *extraData)
{
 const char *tmp;
 int  mode = 0;
 int videoProcess;
	//printf("-Video filter by name : %s\n",name);

	Read(videoProcess);
	// it is a toggle !
	if(videoProcess!=videoProcessMode)
	{ // need to toggle it !
		
		videoProcessMode=videoProcess^1;
		UI_setVProcessToggleStatus( videoProcess );
	}
	else
	printf("Already in good mode (%d)\n",videoProcessMode);


	switch( current_codec)
	{
#define MAKECONF(x)  if(extraLen) {assert(extraLen==sizeof(x));memcpy(&(x),extraData,extraLen);}
#ifdef USE_XX_XVID
      	 	case CodecXvid :

							MAKECONF(xvidConfig);
		      		break;
#endif
#ifdef  USE_FFMPEG
					case CodecMjpeg :

						break;
#endif
#ifdef USE_DIVX

				 	case CodecDivx :
				  			MAKECONF(divxConfig);
		    			break;
#endif

					case CodecVCD:
						break;
					case CodecSVCD:
						MAKECONF(mpeg2encSVCDConfig);
						break;
					case CodecDVD:
						MAKECONF(mpeg2encDVDConfig);
						break;


#ifdef USE_FFMPEG
					case  CodecFF:
					case  CodecH263:
					case  CodecH263P:
					case  CodecHuff:
					case  CodecFFV1:
											MAKECONF(ffmpegConfig);
											break;
					case CodecXVCD:
					case CodecXSVCD:
									MAKECONF(ffmpegMpeg1Config);
									break;
#endif
					default:
								assert(0);

	}

}
/*
	We return 2 things :
			The codec conf : i.e. mode process or not
				and the extraData size

*/

const char  *videoCodecGetConf( uint32_t *optSize, uint8_t **data)
{
	static char conf[400];
	static char tmp[200];
	uint32_t confSize=0;
	conf[0]=0;

	*optSize=0;
	*data=NULL;


	switch( current_codec)
	{
#ifdef USE_XX_XVID
      	 			case CodecXvid :
						*data=(uint8_t *)&xvidConfig;
						*optSize=sizeof(xvidConfig);
		      		break;
#endif
#ifdef  USE_FFMPEG
					case CodecMjpeg :

						break;
#endif
#ifdef USE_DIVX

				 	case CodecDivx :

							*data=(uint8_t *)&divxConfig;
							*optSize=sizeof(divxConfig);
		    			break;
#endif
#ifdef USE_FFMPEG
					case  CodecFF:
					case  CodecH263:
					case  CodecH263P:
					case  CodecHuff:
					case  CodecFFV1:


											*data=(uint8_t *)&ffmpegConfig;
											*optSize=sizeof(ffmpegConfig);
											break;
					case CodecXVCD:
					case CodecXSVCD:

									*data=(uint8_t *)&ffmpegMpeg1Config;
									*optSize=sizeof(ffmpegMpeg1Config);
									break;
#endif
#ifdef USE_MJPEG
					case CodecVCD:
									break;
					case CodecSVCD:									
									*data=(uint8_t *)&mpeg2encSVCDConfig;
									*optSize=sizeof(mpeg2encSVCDConfig);
									break;
					case CodecDVD:
									*data=(uint8_t *)&mpeg2encDVDConfig;
									*optSize=sizeof(mpeg2encDVDConfig);
									break;
#endif
					default:
								assert(0);

	}

	uint8_t videoProcess=videoProcessMode;
	Add(videoProcess);
	confSize=*optSize;
	Add(confSize);

	aprintf("Conf :%s (%d) (%d)\n",conf,videoProcessMode,confSize);
	return conf;

}

//%
void EncoderSaveMpeg(char *name)
{
#ifdef USE_MJPEG
	switch(current_codec)
	{
		case CodecVCD:
				oplug_mpeg_vcd(name);
				break;
		case CodecSVCD:
				oplug_mpeg_svcd(name);
				break;
		case CodecDVD:
				oplug_mpeg_dvd(name);
				break;
		default:assert(0);
	}
#else
	GUI_Alert("** NO MPEG ENCODING SUPPORT**");
#endif

}

/*
	Ultimately that will be dispatched on a per codec
	stuff and will be merged with xml stuff to allow
	save config / load config
*/
void videoCodecConfigureAVI(  char *cmdString,uint32_t optSize, uint8_t *opt)
{
		int  iparam,equal=0xfff;
		COMPRESSION_MODE compmode=(COMPRESSION_MODE)0xff;
	// search the =
			for(unsigned int i=0;i<strlen(cmdString);i++)
			{
				if(*(cmdString+i)=='=')
				{
						equal=i;
						break;
				}
			}
			if(equal==0xfff)
			{
				printf("\n i did not understood the args for video conf\n");
				return;
			}
			*(cmdString+equal)=0;
			iparam=atoi(cmdString+equal+1);
			aprintf("codec conf is %s\n",cmdString);
			// search the codec
			if(!strcmp(cmdString,"cq"))
				{
						compmode=COMPRESS_CQ;
						aprintf("cq Mode\n");
				}
			if(!strcmp(cmdString,"cbr"))
				{
						compmode=COMPRESS_CBR;
						iparam*=1000;
						aprintf("cbr Mode\n");
				}
			if(!strcmp(cmdString,"2pass"))
				{
						compmode=COMPRESS_2PASS;
						aprintf("2pass\n");
				}
			if(compmode==(COMPRESSION_MODE)0xff)
			{
				printf("\n ***** Unknown mode for video codec (%s)\n",cmdString);
				return;
			}

			aprintf("param:%d\n",iparam);
			setVideoEncoderSettings(compmode, iparam,optSize,opt);
			return;
}
#if 0
void videoCodecConfigureMpeg(  char *cmdString)
{
// We accept 3 parameters
		// mbr    : max bitrate in kbps
		// quant : quant in kbps
		// Other : Free string
			char *i=cmdString;
		        if( current_codec == CodecSVCD || current_codec ==CodecDVD ){
				while( i && *i ){
					if( !strncmp(i,"mbr=",4) ){
					   unsigned int br;
						i+=4;
						br = atoi(i);
						prefs->set( (current_codec==CodecSVCD ? CODECS_MPEG2ENC_SVCD_MAXBITRATE : CODECS_MPEG2ENC_DVD_MAXBITRATE), br );
						i = index(i,','); if( i ) i++;
						continue;
					}
					if( !strncmp(i,"quant=",6) ){
					   unsigned int q;
						i+=6;
						q = atoi(i);
						prefs->set( (current_codec==CodecSVCD ? CODECS_MPEG2ENC_SVCD_QUANTISATION : CODECS_MPEG2ENC_DVD_QUANTISATION), q );
						i = index(i,','); if( i ) i++;
						continue;
					}
					if( !strncmp(i,"other=",6) ){
						i+=6;
						prefs->set( (current_codec==CodecSVCD ? CODECS_MPEG2ENC_SVCD_EXTRAPARAMS : CODECS_MPEG2ENC_DVD_EXTRAPARAMS), i );
						i = index(i,','); if( i ) i++;
						continue;
					}
					break;
				}
			}
			if( i && *i )
				fprintf(stderr,"ignoring trailing \"%s\"\n",i);
			return;


}
#endif
void videoCodecConfigure(  char *cmdString,uint32_t optionSize,uint8_t  *option)
{
		CodecFamilty family;

		if(!cmdString) return;

		family=videoCodecGetFamily();
		switch(family)
		{
			case CodecFamilyAVI:
			case CodecFamilyXVCD:
			case CodecFamilyMpeg:
				videoCodecConfigureAVI(cmdString,optionSize,option);
				break;
/*			case CodecFamilyMpeg :
				videoCodecConfigureMpeg(cmdString);			
				break;
*/				
			default:
				printf("This codec family does not accept paramaters\n");
		}

}

void encoderSetLogFile(char *name)
{
		strcpy( TwoPassLogFile,name);
		printf("\n Log file is now :%s\n",TwoPassLogFile);
}
//___________________________________________________
typedef struct codecEnumByName
{
	SelectCodecType type;
	const char	*name;
}codecEnumByName;

static const codecEnumByName mycodec[]=
{
#ifdef USE_DIVX
	{CodecDivx	,"Divx"},
#endif
#ifdef USE_XX_XVID
	{CodecXvid	,	"Xvid"},
#endif


	{CodecMjpeg	,	"Mjpeg"},
#ifdef USE_MJPEG
	{CodecVCD	,	"VCD"},
	{CodecSVCD,	"SVCD"},
	{CodecDVD,		"DVD"},
#endif
	{CodecXVCD,	"XVCD"},
	{CodecXSVCD,	"XSVCD"},
	{CodecFF		,"FFmpeg4"},
	{CodecH263	,	"H263"},
	{CodecH263P	,"H263+"},
	{CodecHuff		,"Huffyuv"},
	{CodecFFV1		,"FFV1"}
};
//___________________________________________________
void saveEncoderConfig( void )
{
	for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
	{
		if(current_codec==mycodec[i].type)
		{
			prefs->set(CODECS_PREFERREDCODEC,mycodec[i].name);
		}

	}
	
}
void loadEncoderConfig ( void )
{
 char *name;
		if(!prefs->get(CODECS_PREFERREDCODEC, &name))
		{
			printf("could not get prefered codec!\n");
			return;
		}
		videoCodecSelectByName(name);
}
void videoCodecSelectByName(const char *name)
{
		for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
		{
			if(!strcmp(name,mycodec[i].name))
			{
				printf("\n Codec %s found\n",name);
				videoCodecSetcodec(mycodec[i].type);
				return;
			}

		}
		printf("\n Mmmm Select codec by name failed...(%s).\n",name);
		printf(" Available codec : %d\n",sizeof(mycodec)/sizeof(codecEnumByName));
		for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
		{
			printf("%s\n",mycodec[i].name);
		}
}

const char *videoCodecGetName( void )
{
	for(uint32_t i=0;i<sizeof(mycodec)/sizeof(codecEnumByName);i++)
	{
		if(current_codec==mycodec[i].type)
		{
			return mycodec[i].name;
		}

	}
	printf("\n Mmmm get video  codec  name failed..\n");
	return NULL;
}

void initEncoders( void)
{
		strcpy( TwoPassLogFile,"/tmp/Xvid2passLog");
}
///
///  Prompt for a codec and allow configuration
///
///______________________________


uint8_t DIA_videoCodec( SelectCodecType *codec );
void videoCodecSelect( void )
{
	DIA_videoCodec( &current_codec );

}
void videoCodecSetcodec(SelectCodecType codec)
{
	current_codec=codec;

}
void videoCodecConfigure( void )
{
	printf("\n configuring codec :%d\n",current_codec);
	switch(current_codec)
			{


		case CodecMjpeg :
						DIA_mjpegCodecSetting(&(mjpegConfig.qual),&(mjpegConfig.swapped));
						break;
#ifdef USE_MJPEG
		case CodecVCD :
						break;
		case CodecSVCD :
						oplug_mpeg_svcdConf( );
						break;
		case CodecDVD :
						oplug_mpeg_dvdConf( );
						break;

#endif
		case CodecXVCD :
		case CodecXSVCD :
						oplug_mpegff_conf();

						break;

#ifdef USE_XX_XVID
      	 	case CodecXvid :
			 		DIA_getXvidCompressParams(&xvidConfig.generic.mode,
							&xvidConfig.generic.qz,
		      					&xvidConfig.generic.bitrate,
		        				&xvidConfig.generic.finalsize,
		                      			&xvidConfig.specific);		
		      			break;
#endif								
#ifdef USE_DIVX
					
		case CodecDivx :
			  		getCompressParams(&divxConfig.generic.mode,
							&divxConfig.generic.qz,
							&divxConfig.generic.bitrate,
							&divxConfig.generic.finalsize);
		    			break;
#endif
#ifdef USE_FFMPEG	
		case CodecHuff:
				break;
		case CodecFFV1:
				break;

		case  CodecH263P:
					printf("\n H263P\n");					
		case  CodecH263:  
					printf("\n H263\n");					
		case  CodecFF:
/*
					getCompressParams(&ffmpegConfig.generic.mode,
							&ffmpegConfig.generic.qz,
							&ffmpegConfig.generic.bitrate,
							&ffmpegConfig.generic.finalsize);	
*/
					getFFCompressParams(&ffmpegConfig.generic.mode,
							&ffmpegConfig.generic.qz,
							&ffmpegConfig.generic.bitrate,
							&ffmpegConfig.generic.finalsize,
							&ffmpegConfig.specific);
							
					break;
#endif
					default:
								assert(0);
					}								  			
	
	
}
/*___________________________________________________________
	Set mode param and extra data for the currently selected codec
	The extradata is a free binary chunk (->memcpy of codec.specific part)
___________________________________________________________*/

void setVideoEncoderSettings(COMPRESSION_MODE mode, uint32_t  param, uint32_t extraConf, uint8_t *extraData)
{
	COMPRES_PARAMS *generic = NULL;
	void *specific=NULL;
	uint32_t specSize=0;

	switch( current_codec)
	{
				case CodecSVCD :
				  		generic=&mpeg2encSVCDConfig.generic;
						specific=&mpeg2encSVCDConfig.specific;
						specSize=sizeof(mpeg2encSVCDConfig.specific);
		      		break;
				case CodecDVD :
				  		generic=&mpeg2encDVDConfig.generic;
						specific=&mpeg2encDVDConfig.specific;
						specSize=sizeof(mpeg2encDVDConfig.specific);
		      		break;
				case CodecVCD:
						printf("No conf for VCD!\n");
				break;
#ifdef USE_XX_XVID
      	 			case CodecXvid :
				  		generic=&xvidConfig.generic;
						specific=&xvidConfig.specific;
						specSize=sizeof(xvidConfig.specific);
		      		break;
#endif
#ifdef  USE_FFMPEG
					case CodecMjpeg :

						break;
#endif
#ifdef USE_DIVX

				 	case CodecDivx :
				  			generic=&divxConfig.generic;
							specific=&divxConfig.specific;
							specSize=sizeof(divxConfig.specific);
		    			break;
#endif
#ifdef USE_FFMPEG
					case  CodecFF:
					case  CodecH263:
					case  CodecH263P:
					case  CodecHuff:
					case  CodecFFV1:

											generic=&ffmpegConfig.generic ;
											specific=&ffmpegConfig.specific;
											specSize=sizeof(ffmpegConfig.specific);
											break;
					case CodecXVCD:
					case CodecXSVCD:
									generic=&ffmpegMpeg1Config.generic;
									specific=&ffmpegMpeg1Config.specific;
									specSize=sizeof(ffmpegMpeg1Config.specific);
									break;
#endif
					default:
								assert(0);

	}
	  generic->mode=mode;
	  switch(mode)
	  {
				case COMPRESS_CBR:
								aprintf("CBR : %lu kbps\n",param);
								generic->bitrate=param;
								break;
				case COMPRESS_CQ:
								aprintf("CQ : %lu q\n",param);
								generic->qz=param;
								break;
				case COMPRESS_2PASS:
								aprintf("2pass : %lu q\n",param);
								generic->finalsize=param;
								break;
				default:
								assert(0);												
															
		}

	if(extraConf && extraData && specific)
	{
		if(specSize!=extraConf)
		{
			printf("\n*** ERROR : Extra data for codec config has a different size!!! *****\n");
			printf("\n*** ERROR : Extra data for codec config has a different size!!! *****\n");
			printf("\n*** ERROR : Extra data for codec config has a different size!!! *****\n");
		}
		else
		{
			printf("\n using %lu bytes of codec specific data...\n",extraConf);
			memcpy(specific,extraData,extraConf);
		}
	}
}
Encoder *getVideoEncoder( uint32_t w,uint32_t h )

{

//int s;
Encoder *e=NULL;

		switch(current_codec)
			{
#ifdef USE_FFMPEG
#ifndef USE_DIVX
					default:				  
#endif
      	 	case CodecFF :   								  
				  		e=new   EncoderFFMPEG(FF_MPEG4,&ffmpegConfig);
				    	break;			
#endif		

#ifdef USE_FFMPEG
		case   CodecHuff:
					e=new   EncoderFFMPEGHuff(&ffmpegConfig);
				    	break;
		case   CodecFFV1:
					e=new   EncoderFFMPEGFFV1(&ffmpegConfig);
				    	break;
		case   CodecH263P:
					e=new   EncoderFFMPEG(FF_H263P,&ffmpegConfig);
				    	break;		
      	 	case CodecH263 : 
         			if( !((w==128) && (h=96)) &&
            		! ((w==176) && (h=144))) 
              	{
								  	GUI_Alert("Only Qcif and SubQcif allowed \n for H263 codec");
								    return 0;
								 } 								  
				  		e=new   EncoderFFMPEG(FF_H263,&ffmpegConfig);
				    	break;			
#endif										
				
#ifdef USE_XX_XVID
      	 				case CodecXvid :   								  
				  		e=new   EncoderXvid( &xvidConfig); 
				    	break;
#endif								
#ifdef  USE_FFMPEG
					case CodecMjpeg :
							e=new   EncoderMjpeg(&mjpegConfig); break;
#endif
#ifdef USE_DIVX
					default:				  
				 	case CodecDivx :   
				  		e=new   EncoderDivx(&divxConfig); break;
#endif				    
				  			
			
				}
         if(!e) 
#ifdef USE_DIVX         	
          e=new   EncoderDivx(&divxConfig);
#else
					e=new   EncoderFFMPEG(FF_MPEG4,&ffmpegConfig);
#endif          
		return e;
	
}

